<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="物料编码" prop="materialCode">
        <el-input
          v-model="queryParams.materialCode"
          placeholder="请输入物料编码"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item label="物料名称" prop="materialName">
        <el-input
          v-model="queryParams.materialName"
          placeholder="请输入物料名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="物料大类" prop="materialCategories">
        <el-input
          v-model="queryParams.materialCategories"
          placeholder="请输入物料大类"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="物料类型" prop="materialTypeId">
        <el-input
          v-model="queryParams.materialTypeId"
          placeholder="请输入物料类型"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="materialinfoList" @selection-change="handleSelectionChange"
              @row-click="handleRowClick"
              highlight-current-row
    >
      <el-table-column type="selection" width="55" align="center" v-if="false" />
      <el-table-column label="物料编码" align="center" prop="materialCode" />
      <el-table-column label="物料名称" align="center" prop="materialName" />
      <el-table-column label="物料大类" align="center" prop="materialCategories" />
      <el-table-column label="物料类型" align="center" prop="materialTypeId" />
      <el-table-column label="批次标识" align="center" prop="batchFlag" />
      <el-table-column label="计量单位" align="center" prop="materialUnit" />
      <el-table-column label="物料规格" align="center" prop="materialSpec" />
      <el-table-column label="净重" align="center" prop="netWeight" />
      <el-table-column label="毛重" align="center" prop="grossWeight" />
<!--      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">-->
<!--        <template slot-scope="scope">-->
<!--          <el-button-->
<!--            size="mini"-->
<!--            type="text"-->
<!--            icon="el-icon-edit"-->
<!--            @click="handleUpdate(scope.row)"-->
<!--            v-hasPermi="['mes:materialinfo:edit']"-->
<!--          >修改</el-button>-->
<!--          <el-button-->
<!--            size="mini"-->
<!--            type="text"-->
<!--            icon="el-icon-delete"-->
<!--            @click="handleDelete(scope.row)"-->
<!--            v-hasPermi="['mes:materialinfo:remove']"-->
<!--          >删除</el-button>-->
<!--        </template>-->
<!--      </el-table-column>-->
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

  </div>
</template>

<script>
import { listMaterialinfo, getMaterialinfo, delMaterialinfo, addMaterialinfo, updateMaterialinfo } from "@/api/mes/materialinfo";

export default {
  name: "Materialinfo",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 物料信息表格数据
      materialinfoList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        erpId: null,
        materialCode: null,
        oldMaterialCode: null,
        materialName: null,
        materialCategories: null,
        materialSubclass: null,
        materialTypeId: null,
        batchFlag: null,
        materialUnitId: null,
        materialUnit: null,
        materialMatkl: null,
        materialSpec: null,
        netWeight: null,
        grossWeight: null,
        factoryId: null,
        createOrgId: null,
        useOrgId: null,
        prodlineId: null,
        activeFlag: null,
        deletedFlag: null,
        approveDate: null,
        erpModifyDate: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        erpId: [
          { required: true, message: "ERP的主键;对应FMATERIALID不能为空", trigger: "blur" }
        ],
        materialCode: [
          { required: true, message: "物料编码;对应ERP的FNumber不能为空", trigger: "blur" }
        ],
        materialName: [
          { required: true, message: "物料名称;对应ERP的FName不能为空", trigger: "blur" }
        ],
        materialCategories: [
          { required: true, message: "物料大类(1,原材料 2,半成品 3,成品)不能为空", trigger: "blur" }
        ],
        materialTypeId: [
          { required: true, message: "物料类型，关联mes_base_material_type的material_type_id不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询物料信息列表 */
    getList() {
      this.loading = true;
      listMaterialinfo(this.queryParams).then(response => {
        this.materialinfoList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        materialId: null,
        erpId: null,
        materialCode: null,
        oldMaterialCode: null,
        materialName: null,
        materialCategories: null,
        materialSubclass: null,
        materialTypeId: null,
        batchFlag: null,
        materialUnitId: null,
        materialUnit: null,
        materialMatkl: null,
        materialSpec: null,
        netWeight: null,
        grossWeight: null,
        factoryId: null,
        createOrgId: null,
        useOrgId: null,
        prodlineId: null,
        activeFlag: null,
        deletedFlag: null,
        remark: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        approveDate: null,
        erpModifyDate: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.materialId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加物料信息";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const materialId = row.materialId || this.ids
      getMaterialinfo(materialId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改物料信息";
      });
    },
    //选中列赋值
    handleRowClick(row) {
      this.selectedRow = row
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.materialId != null) {
            updateMaterialinfo(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addMaterialinfo(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const materialIds = row.materialId || this.ids;
      this.$modal.confirm('是否确认删除物料信息编号为"' + materialIds + '"的数据项？').then(function() {
        return delMaterialinfo(materialIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('mes/materialinfo/export', {
        ...this.queryParams
      }, `materialinfo_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
